--
-- InteractiveButtons
-- Specialization for an interactive control button
--
-- @author  	Manuel Leithner (SFM-Modding)
-- @version 	v2.1
-- @date  		29/08/11
-- @history:	v1.0 - Initial version
--				v2.0 - converted to ls2011
--				v2.1 - improvements
--

InteractiveButtons = {};

function InteractiveButtons.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(InteractiveControl, specializations);
end;

function InteractiveButtons:load(xmlFile)

	local i=0;
	while true do
		local buttonName = string.format("vehicle.interactiveComponents.buttons.button(%d)", i);	
		if not hasXMLProperty(xmlFile, buttonName) then
			break;
		end;
		local name = Utils.getNoNil(g_i18n:getText(getXMLString(xmlFile, buttonName .. "#name")), "ERROR");
		local mark = Utils.indexToObject(self.components, getXMLString(xmlFile, buttonName .. "#mark"));
		local highlight;
		local xRot = getXMLFloat(xmlFile, buttonName .. "#xRot");
		local yRot = getXMLFloat(xmlFile, buttonName .. "#yRot");
		local zRot = getXMLFloat(xmlFile, buttonName .. "#zRot");
		if xRot == nil and yRot == nil and zRot == nil then
			highlight = getChildAt(mark, 0);
		end;		
		local size = Utils.getNoNil(getXMLFloat(xmlFile, buttonName .. "#size"), 0.1);
		local event = getXMLString(xmlFile, buttonName .. "#event");
		local onMessage = g_i18n:getText(Utils.getNoNil(getXMLString(xmlFile, buttonName .. "#onMessage"), "ic_button_on"));
		local offMessage =  g_i18n:getText(Utils.getNoNil(getXMLString(xmlFile, buttonName .. "#offMessage") , "ic_button_off"));
	
		local button = Button:new(nil, highlight, name, mark, xRot, yRot, zRot, size, event, self, onMessage, offMessage, self.infoBar);
		
		button.synch = Utils.getNoNil(getXMLBool(xmlFile, buttonName .. "#synch"), false);

		table.insert(self.interactiveObjects, button);
		i = i + 1;
	end;
end;

function InteractiveButtons:delete()
end;

function InteractiveButtons:mouseEvent(posX, posY, isDown, isUp, button)
end;

function InteractiveButtons:keyEvent(unicode, sym, modifier, isDown)
end;

function InteractiveButtons:update(dt)	
end;

function InteractiveButtons:draw()
end;



--
-- Button Class
-- Specifies an interactive Button
--
-- SFM-Modding
-- @author  Manuel Leithner
-- @date  29/08/11
--

Button = {};

function Button:new(node, highlight, name, mark, xRot, yRot, zRot, size, event, vehicle, onMessage, offMessage, infobar)

	local Button_mt = Class(Button, InteractiveComponentInterface);	
    local instance = InteractiveComponentInterface:new(node, highlight, name, mark, xRot, yRot, zRot, size, onMessage, offMessage, infobar, Button_mt);

	instance.vehicle = vehicle;
	instance.event = event;
	instance.lastdt = 100;
	return instance;	
end;

function Button:delete()
	InteractiveComponentInterface.delete(self);
end;

function Button:mouseEvent(posX, posY, isDown, isUp, button)
	InteractiveComponentInterface.mouseEvent(self, posX, posY, isDown, isUp, button);
end;

function Button:keyEvent(unicode, sym, modifier, isDown)
	InteractiveComponentInterface.keyEvent(self, unicode, sym, modifier, isDown);
end;

function Button:update(dt)
	self.lastdt = dt;
	if self.vehicle ~= nil then
		if self.event == "toggleWorkingLightFront" then		
			self.isOpen = self.vehicle.B3["highbeam"][1].a;
		elseif self.event == "toggleSteeringLock" then
			self.isOpen = self.vehicle.tigerSteer.fixedSteering;
		elseif self.event == "toggleStartMotor" then
			self.isOpen = self.vehicle.isMotorStarted;
		elseif self.event == "toggleStdLights" then
			self.isOpen = self.vehicle.lightsActive;
		elseif self.event == "toggleFlashers" then		
			self.isOpen = self.vehicle.B3.wl;			
		elseif self.event == "toggleSpeedMode" then	
			self.isOpen = self.vehicle.tigerSteer.speedMode;
		end;		
	end;
	InteractiveComponentInterface.update(self, dt);
end;

function Button:draw()
	InteractiveComponentInterface.draw(self);
end;

function Button:doAction(noEventSend, forceAction)
	if self.vehicle ~= nil then
		if self.event == "toggleWorkingLightFront" then	
			if forceAction == nil then
				local lt = self.vehicle.B3["highbeam"];	
				self.vehicle:setState("highbeam", not lt[1].a, noEventSend);
			else
				self.vehicle:setState("highbeam", forceAction, noEventSend);
			end;
		elseif self.event == "toggleStartMotor" then
			if self.vehicle.isMotorStarted then
				self.vehicle:invokeIgnition(false);
			else
				self.vehicle:invokeIgnition(true);
			end;
		elseif self.event == "toggleSteeringLock" then
			local newValue = not self.vehicle.tigerSteer.fixedSteering;
			self.vehicle:setTigerFixedSteer(newValue, noEventSend);
		elseif self.event == "toggleStdLights" then
			if self.vehicle.lightsActive then
				self.vehicle:setLightsVisibility(false, noEventSend);
			else
				self.vehicle:setLightsVisibility(true, noEventSend);
			end;
		elseif self.event == "toggleFlashers" then
			if self.vehicle.B3.wl then
				self.vehicle:setState("warnlights", false, noEventSend);
				self.vehicle:setState("dirLeft", false, noEventSend);
				self.vehicle:setState("dirRight", false, noEventSend);
			else
				self.vehicle:setState("warnlights", true, noEventSend);
				self.vehicle:setState("dirLeft", true, noEventSend);
				self.vehicle:setState("dirRight", true, noEventSend);
			end;			
		elseif self.event == "toggleSpeedMode" then
			if self.vehicle.tigerSteer.speedMode then
				self.vehicle:setTigerSpeedMode(false, noEventSend);
			else
				self.vehicle:setTigerSpeedMode(true, noEventSend);
			end;
		elseif self.event == "lowerArm" then
			if self.vehicle.isWorkingMode then
				--local ctA1 = getAnimTrackTime(self.vehicle.wtAnimA1.charSet, 0);
				--local targetTime = Utils.getMovedLimitedValues({ctA1}, {0}, {self.vehicle.wtAnimA1.duration}, 1, 3*self.vehicle.wtAnimA1.duration, self.lastdt, true);
				self.vehicle:setArmPosition(self.vehicle.wtAnimA1.duration, noEventSend);
				--print("ctA1="..tostring(ctA1));
			end;
		elseif self.event == "raiseArm" then
			if self.vehicle.isWorkingMode then
			--local ctA1 = getAnimTrackTime(self.vehicle.wtAnimA1.charSet, 0);
			--local targetTime = Utils.getMovedLimitedValues({ctA1}, {0}, {self.vehicle.wtAnimA1.duration}, 1, 3*self.vehicle.wtAnimA1.duration, self.lastdt, false);
				self.vehicle:setArmPosition(0, noEventSend);
			end;				
		elseif self.event == "discharge" then
			self.vehicle:setDischarge(not self.vehicle.disBand.doDis, noEventSend);
		end;	
	end;
end;

function Button:onEnter(dt)
	InteractiveComponentInterface.onEnter(self, dt);
end;

function Button:onExit(dt)
	InteractiveComponentInterface.onExit(self, dt);
end;

function Button:setActive()
	InteractiveComponentInterface.setActive(self, isActive);
end;

function Button:setVisible(isVisible)
	InteractiveComponentInterface.setVisible(self, isVisible);
end;